package org.openjdk.shenandoah.wip;

import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(1)
@State(Scope.Benchmark)
public class WriteBarriersNullCheck {

    Target target;
    Target targetNull;

    @Setup
    public void setup() {
        target = new Target();
        targetNull = null;
    }

    @Benchmark
    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
    public void storeToNull() {
        try {
            targetNull.field = null;
        } catch (NullPointerException e) {
            // expected
        }
   }

    @Benchmark
    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
    public void storeNull() {
        target.field = null;
    }

    static class Target {
        Object field;
    }

}
